NumberOfDiscIntersections--重点

Problem:
We draw N discs on a plane. The discs are numbered from 0 to N − 1. A zero-indexed array A of N non-negative integers, specifying the radiuses of the discs, is given. The J-th disc is drawn with its center at (J, 0) and radius A[J].

We say that the J-th disc and K-th disc intersect if J ≠ K and the J-th and K-th discs have at least one common point (assuming that the discs contain their borders).

The figure below shows discs drawn for N = 6 and A as follows:

A[0] = 1
A[1] = 5
A[2] = 2
A[3] = 1
A[4] = 4
A[5] = 0

There are eleven (unordered) pairs of discs that intersect, namely:

discs 1 and 4 intersect, and both intersect with all the other discs;
disc 2 also intersects with discs 0 and 3.
Write a function:

class Solution { public int solution(int[] A); }

that, given an array A describing N discs as explained above, returns the number of (unordered) pairs of intersecting discs. The function should return −1 if the number of intersecting pairs exceeds 10,000,000.

Given array A shown above, the function should return 11, as explained above.

Assume that:

N is an integer within the range [0..100,000];
each element of array A is an integer within the range [0..2,147,483,647].
Complexity:

expected worst-case time complexity is O(N*log(N));
expected worst-case space complexity is O(N), beyond input storage (not counting the storage required for input arguments).
Elements of input arrays can be modified.

解答:

My method and understanding

问题可以简化成若干个1D的intervals, 每个interval的中点有序,求相交的pair 数目。[startpoint, endpoint]

这里需要注意的就是每个interval 代表一个disc,每个disc的center都是从0到N-1的连续integer,所以我们要从第一个disc开始遍历,check这个disc是否与其他的discs相交。把这个问题再抽象一点,

就是对于第i个current disc,我们要check他后面的discs j(j>i) 有多少与current disc相交。我们不care 是否第i个disc之前的disc是否相交

这里要求O(N*log(N)),很容易想到要sort,其实还可以想到要tranverse一个N array,即O(N), 然后每一element进行一次binary search,每次binary search时O(logN), 最后也是O(N*log(N))

对于第i个current disc, 我要check 其end point在start point list中的位置,所以先sort start point list, 然后使用binary search,得到index。

每一个s是startpoint list的元素,已经sorted成ascending order. 我们将问题进一步formulate成 s1,s2,...,sindex,ei,sindex+1 , ei 经过binary search 发现恰好位于 [sindex,sindex+1] 之间。现在我们要说明的就是, 在disc j(j>i)中,与current disc相交的disc 数目= index - 1 - (i-1)个。1代表第i个disc的s_i也在 [s1,sindex] 之间,应该排除掉。(i-1)代表第i个disc之前的discs,这里我们不考虑,我们要考虑第i个disc之后的discs中有多少与第i个相交。

其实 [s1,sindex] 由三个部分组成,

第一个自然是 si ,对应第i个disc的start point.

第二部分就是 sn,n<i ,就是第i个disc之前的所有disc的start point, 因为disc的摆放顺序,后面的disc的中点要大于前面disc的中点,所以, 2sn<sn+en<si+ei<2ei , 所以当我们在start point的sorted list里面搜索e_i时,所有的 sn 肯定在 [s1,sindex] 内部。

第三部分就是 sm,i<m<index ,是我们的解空间 sm,m>i 中的一部分,正是我们想要的,那么这部分中又有多少与第i个disc相交的呢?答案是所有。因为 2em>sm+em>si+ei>2si , i.e. em>si ,即所有 sm 对应的 em 都是大于 si 的,把 si 包括在 sm em 之间,所以一定会与第i个disc相交。

因此,我们只需要求得第i个disc的end point 在ascending的start point list中的index,就可以求出其与后面的discs相交的次数。

Other O(N*logN) understanding

http://rafal.io/posts/codility-intersecting-discs.html
http://codesays.com/2014/solution-to-beta2010-number-of-disc-intersections-by-codility/

Here is a O(N)

http://stackoverflow.com/questions/4801242/algorithm-to-calculate-number-of-intersecting-discs

http://www.careercup.com/question?id=15519765

你可能感兴趣的:(NumberOfDiscIntersections--重点)